<?php
      /*
      Plugin Name: PubMan Content 
      Plugin URI: http://colab.mpdl.mpg.de/mediawiki/User:Andi
      Description: Plugin to fetch contents from PubMan and display it
      Author: Andreas Gros 
      Version: 0.2
			Author URI:http://colab.mpdl.mpg.de/mediawiki/User:Andi
      */


     	if(!class_exists("PubManPlugin")){

				class PubManPlugin {
					var $adminOptionsName = "PubManPluginAdminOptions";
					var $availableCitationStyles = array("APA");

					function PubManPlugin(){ // constructor
						add_action('plugins_loaded', array(&$this, 'init_pubman'));
						
						// Hook for theme coders/hackers
            add_action('pubman_content', array(&$this, 'display_pubmancontent'));

            // Makes it backwards compat pre-2.5 I hope
            if ( function_exists('add_shortcode') ) {
                add_shortcode('pubman-content', array(&$this, 'my_shortcode_handler'));
             }
					}

					//************** init: called upon plugin installation + instantiation *****************
					function init() {
						$this->getAdminOptions();
					}
						
					//************** Get/Set the options *****************
					function getAdminOptions(){
						//set the default option values
						$pubmanContentAdminOptions = array('baseURLForLinks' => 'http://pubman.mpdl.mpg.de/pubman/faces/viewItemFullPage.jsp?itemId=',
																							 'defaultCitationStyle' => 'APA',
																							 'defaultSearchString' => 'gros'); 
						//check for previously set option values
						$pubmanOptions = get_option($this->adminOptionsName);
						if(!empty($pubmanOptions)){
							foreach($pubmanOptions as $key => $option) {	$pubmanContentAdminOptions[$key] = $option;	}
						}
						update_option($this->adminOptionsName, $pubmanContentAdminOptions);
						return $pubmanContentAdminOptions;
					}

					//************** Enable display with correct css settings (add pubman-css) *****************
					function addHeaderCode() {
						echo '<link type="text/css" rel="stylesheet" href="' . get_bloginfo('wpurl') . '/wp-content/plugins/pubman/css/pubman.css" />';	
					}
					


					//********************widget functions********************
					function pubman_widget() {
						$pubmanOptions = get_option($this->adminOptionsName);

						echo"<h2>PubMan Content</h2> \n";
						$this->display_pubmancontent(array("searchstring" => $pubmanOptions['defaultSearchString'], 
																							 "citationstyle" => $pubmanOptions['defaultCitationStyle']));
					}

					function init_pubman(){
						if ( !function_exists('register_sidebar_widget') )
							return;
						register_sidebar_widget("PubMan", "pubman_widget");     
					}


					//********************get content out of pubman********************
					function display_pubmancontent($atts) {
						global $state;
						global $publicationdata;
						global $publicationcount;
						
						$pubmanOptions = get_option($this->adminOptionsName);

						$publicationcount = 0;
						
						if(is_array($atts))
							{
							$searchString		= $atts['searchstring'];
							$citationStyle	= $atts['citationstyle'];
							}
						if(!isset($citationStyle) || (strlen($citationStyle) == 0)) {$citationStyle =  $pubmanOptions['defaultCitationStyle']; }
						if(!isset($searchString) || (strlen($searchString) == 0)) {$searchString = $pubmanOptions['defaultSearchString']; }
						$searchURL = "http://pubman.mpdl.mpg.de/search/SearchAndExport?cqlQuery=";
						$query   = "escidoc.metadata=" . $searchString;
						$request = $searchURL . $query . "&exportFormat=" . $citationStyle . "&outputFormat=snippet&language=all";
						$snippet = file_get_contents($request);
						$state='';
						if (!($xml_parser = xml_parser_create()))
							die("Couldn't create parser.");
						xml_set_element_handler($xml_parser,"startElementHandler","endElementHandler");
						xml_set_character_data_handler( $xml_parser, "characterDataHandler");

						if(!xml_parse($xml_parser, $snippet)) {
							die(sprintf("XML error: %s at line %d",
												xml_error_string(xml_get_error_code($xml_parser)),
												xml_get_current_line_number($xml_parser)));
						}
						xml_parser_free($xml_parser);
						$retstr = "";
						for ($i=0;$i<$publicationcount; $i++) {
							$retstr .= str_replace("<br/>", "", $publicationdata[$i]["citation"]) . "&nbsp;<a href=\"" . $pubmanOptions['baseURLForLinks']  . $publicationdata[$i]["escidocitem"] . "\" >[LINK]</a><br/><br/>\n";
						}
						return $retstr;
					}


					function my_shortcode_handler($atts, $content=null) {
            //global $settings;
            //$settings = get_option($this->adminOptionsName);
            return $this->display_pubmancontent($atts);
            //unset($settings);
					}
					
					// *********** inline replacement callback support **************
					function inline_replace_callback($matches) {

            if ( ! strlen($matches[1]) ) { // Default
                $searchstring = '';
            } else {
                $searchstring = substr($matches[1], 1); // Skip 
            }
            return $this->display_pubmancontent($searchstring);
					}


				// *********** Admin Options **************
				function printAdminPage() {
          $pubmanOptions = $this->getAdminOptions();

          if (isset($_POST['update_pubmanContentSettings'])) {
            if (isset($_POST['baseURLForLinks'])) {
              $pubmanOptions['baseURLForLinks'] = $_POST['baseURLForLinks'];
            }   
            if (isset($_POST['defaultCitationStyle'])) {
              $pubmanOptions['defaultCitationStyle'] = $_POST['defaultCitationStyle'];
            }   
            if (isset($_POST['defaultSearchString'])) {
              $pubmanOptions['defaultSearchString'] = $_POST['defaultSearchString'];
            }   
          update_option($this->adminOptionsName, $pubmanOptions);
                        ?>

<div class="updated"><p><strong><?php _e("Settings Updated.", "PubMan Content Plugin");?></strong></p></div>

       <?php

      } ?>
      <div class=wrap>
      <form method="post" action="<?php echo $_SERVER["REQUEST_URI"]; ?>">
      <h2>PubMan Content Plugin</h2>
      <h3>Set the base URL for Links to PubMan</h3>
			<p><label for="updateBaseURLForLinks"><input type="text" id="baseURLForLinks" name="baseURLForLinks" value="<?php if (strlen($pubmanOptions['baseURLForLinks'])>0) _e($pubmanOptions['baseURLForLinks']); ?>" /> Base-URL for links to PubMan</label><br/></p>
      <h3>Set the default search string</h3>
			<p><label for="updateDefaultSearchString"><input type="text" id="defaultSearchString" name="defaultSearchString" value="<?php if (strlen($pubmanOptions['defaultSearchString'])>0) _e($pubmanOptions['defaultSearchString']); ?>" /> Default search string</label><br/></p>
      <h3>Set the default citation style</h3>
      <p><label for="defaultCitationStyle_yes"><select id="defaultCitationStyle" name="defaultCitationStyle"><?php 
			foreach($this->availableCitationStyles as $style){
				if($style == $pubmanOptions['defaultCitationStyle']) {$optionstr = '<option selected="selected">';}
				else {$optionstr = "<option>";}
				_e($optionstr . $style . "</option>");
			}
			 ?>
			</select> Available citation styles</label>
       
      <div class="submit">
      <input type="submit" name="update_pubmanContentSettings" value="<?php _e('Update Settings', 'PubManContentPlugin') ?>" /></div>
      </form>
       </div>
<?php
					}//End function printAdminPage()
				}//end class 	
			}//end if !class exists

if(class_exists("PubManPlugin")){
	$pubmanPlugin = new PubManPlugin();	
}

//Initialize the admin panel
if (!function_exists("PubManContentPlugin_ap")) {
	function PubManContentPlugin_ap() {
		global $pubmanPlugin;
		if (!isset($pubmanPlugin)) {
			return;
		}
		if (function_exists('add_options_page')) {
			add_options_page('PubMan Content Plugin', 'PubMan Content Plugin Config', 9, basename(__FILE__), array(&$pubmanPlugin, 'printAdminPage'));
		}
	}	
}
if (isset($pubmanPlugin)) {
	//Actions
	add_action('admin_menu', 'PubManContentPlugin_ap');
	add_action('activate_pubman/pubman_plugin.php',  array(&$pubmanPlugin, 'init'));
	add_action('wp_head', array(&$pubmanPlugin, 'addHeaderCode'), 1);
}


//***********************support functions for parsing xml (depends on expat)***********************
function startElementHandler ($parser,$name,$attrib){
	global $state;
	global $publicationdata;
	global $publicationcount;

	switch ($name) {
		case $name=="DCTERMS:BIBLIOGRAPHICCITATION" : {
			$state = "citation";
			break;
		}
		case $name=="ESCIDOCITEM:ITEM" : {
			$publicationdata[$publicationcount]["escidocitem"] = $attrib['OBJID'];
			break;
		}
	}
}
	
function endElementHandler ($parser,$name){
	global $publicationcount;
	global $state;
	$state='';
	if($name=="DCTERMS:BIBLIOGRAPHICCITATION") {$publicationcount++;}
}

function characterDataHandler ($parser, $data) {
	global $publicationdata;
	global $publicationcount;
	global $state;
	if (!$state) {return;}
	if ($state=="citation") { $publicationdata[$publicationcount]["citation"] = $data;}
}
			
?>
